commit 8f8961e382df551150816e7eede21af7f1765b92
Author: jklowden <jklowden>
Date:   Fri Nov 14 05:58:14 2008 +0000

    better metadata and -V option for ODBC version

diff --git a/ChangeLog b/ChangeLog
index eea9680..fb37ad3 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Nov 14 00:56:39 EST 2008	JK Lowden <jklowden@freetds.org>
+	* src/apps/bsqlodbc.c 
+	- better metadata and -V option for ODBC version
+
 Wed Nov 12 21:58:17 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* Makefile.am config.rpath: fix an issue with some libtool version
 
@@ -943,4 +947,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2661 2008/11/12 20:58:45 freddy77 Exp $
+$Id: ChangeLog,v 1.2662 2008/11/14 05:58:14 jklowden Exp $
diff --git a/src/apps/bsqlodbc.c b/src/apps/bsqlodbc.c
index 89d9c19..c8e7b06 100644
--- a/src/apps/bsqlodbc.c
+++ b/src/apps/bsqlodbc.c
@@ -50,7 +50,7 @@
 #include <sqlext.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqlodbc.c,v 1.10 2008/02/13 08:52:09 freddy77 Exp $";
+static char software_version[] = "$Id: bsqlodbc.c,v 1.11 2008/11/14 05:58:14 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char * next_query(void);
@@ -79,6 +79,7 @@ typedef struct _options
 { 
 	int 	fverbose, 
 		fquiet;
+	size_t	odbc_version;
 	FILE 	*headers, 
 		*verbose;
 	char 	*servername, 
@@ -273,7 +274,7 @@ main(int argc, char *argv[])
 	}
 	assert(hEnv);
 
-	if ((erc = SQLSetEnvAttr(hEnv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) SQL_OV_ODBC3, SQL_IS_UINTEGER)) != SQL_SUCCESS) {
+	if ((erc = SQLSetEnvAttr(hEnv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)options.odbc_version, SQL_IS_UINTEGER)) != SQL_SUCCESS){
 		odbc_herror(SQL_HANDLE_DBC, hDbc, erc, "SQLSetEnvAttr", "failed to set SQL_OV_ODBC3");
 		exit(EXIT_FAILURE);
 	}
@@ -413,6 +414,54 @@ free_metadata(struct METADATA *metadata, struct DATA *data, int ncols)
 	free(data);
 }
 
+const char *
+prtype(SQLSMALLINT type)
+{
+	static char buffer[64];
+	
+	switch(type) {
+	case SQL_UNKNOWN_TYPE:		return "SQL_UNKNOWN_TYPE";
+	case SQL_CHAR:			return "SQL_CHAR";
+	case SQL_NUMERIC:		return "SQL_NUMERIC";
+	case SQL_DECIMAL:		return "SQL_DECIMAL";
+	case SQL_INTEGER:		return "SQL_INTEGER";
+	case SQL_SMALLINT:		return "SQL_SMALLINT";
+	case SQL_FLOAT:			return "SQL_FLOAT";
+	case SQL_REAL:			return "SQL_REAL";
+	case SQL_DOUBLE:		return "SQL_DOUBLE";
+#if (ODBCVER >= 0x0300)
+	case SQL_DATETIME:		return "SQL_DATETIME";
+#else
+	case SQL_DATE:			return "SQL_DATE";
+#endif
+	case SQL_VARCHAR:		return "SQL_VARCHAR";
+#if (ODBCVER >= 0x0300)
+	case SQL_TYPE_DATE:		return "SQL_TYPE_DATE";
+	case SQL_TYPE_TIME:		return "SQL_TYPE_TIME";
+	case SQL_TYPE_TIMESTAMP:	return "SQL_TYPE_TIMESTAMP";
+#endif
+#if (ODBCVER >= 0x0300)
+	case SQL_INTERVAL:		return "SQL_INTERVAL";
+#else
+	case SQL_TIME:			return "SQL_TIME";
+#endif  /* ODBCVER >= 0x0300 */
+	case SQL_TIMESTAMP:		return "SQL_TIMESTAMP";
+	case SQL_LONGVARCHAR:		return "SQL_LONGVARCHAR";
+	case SQL_BINARY:		return "SQL_BINARY";
+	case SQL_VARBINARY:		return "SQL_VARBINARY";
+	case SQL_LONGVARBINARY:		return "SQL_LONGVARBINARY";
+	case SQL_BIGINT:		return "SQL_BIGINT";
+	case SQL_TINYINT:		return "SQL_TINYINT";
+	case SQL_BIT:			return "SQL_BIT";
+#if (ODBCVER >= 0x0350)
+	case SQL_GUID:			return "SQL_GUID";
+#endif  /* ODBCVER >= 0x0350 */
+	}
+
+	sprintf(buffer, "unknown: %d", (int)type);
+	return buffer;
+}
+
 static void
 print_results(SQLHSTMT hStmt) 
 {
@@ -460,8 +509,8 @@ print_results(SQLHSTMT hStmt)
 		 */
 
 		fprintf(options.verbose, "Metadata\n");
-		fprintf(options.verbose, "%-6s  %-30s  %-30s  %-15s  %-6s  %-6s  \n", "col", "name", "source", "type", "size", "varies");
-		fprintf(options.verbose, "%.6s  %.30s  %.30s  %.15s  %.6s  %.6s  \n", dashes, dashes, dashes, dashes, dashes, dashes);
+		fprintf(options.verbose, "%-6s  %-30s  %-10s  %-18s  %-6s  %-6s  \n", "col", "name", "type value", "type name", "size", "varies");
+		fprintf(options.verbose, "%.6s  %.30s  %.10s  %.18s  %.6s  %.6s  \n", dashes, dashes, dashes, dashes, dashes, dashes);
 		for (c=0; c < ncols; c++) {
 			/* Get and print the metadata.  Optional: get only what you need. */
 			SQLCHAR name[512];
@@ -478,8 +527,8 @@ print_results(SQLHSTMT hStmt)
 			metadata[c].name = strdup((char *) name);
 			metadata[c].width = (ndigits > metadata[c].size)? ndigits : metadata[c].size;
 
-			fprintf(options.verbose, "%6d  %30s  %30s  %15s  %6lu  %6d  \n", 
-				c+1, metadata[c].name, metadata[c].source, "(todo)", 
+			fprintf(options.verbose, "%6d  %30s  %10d  %18s  %6lu  %6d  \n", 
+				c+1, metadata[c].name, (int)metadata[c].type, prtype(metadata[c].type), 
 				(long unsigned int) metadata[c].size,  -1);
 
 #if 0
@@ -737,6 +786,7 @@ get_login(int argc, char *argv[], OPTIONS *options)
 	
 	options->appname = tds_basename(argv[0]);
 	options->colsep = default_colsep; /* may be overridden by -t */
+	options->odbc_version = SQL_OV_ODBC3;	  /* may be overridden by -V */
 	
 	login = calloc(1, sizeof(LOGINREC));
 	
@@ -749,7 +799,8 @@ get_login(int argc, char *argv[], OPTIONS *options)
 		perror("unable to get hostname");
 	} 
 
-	while ((ch = getopt(argc, argv, "U:P:S:dD:i:o:e:t:hqv")) != -1) {
+	while ((ch = getopt(argc, argv, "U:P:S:dD:i:o:e:t:V:hqv")) != -1) {
+		char *p;
 		switch (ch) {
 		case 'U':
 			login->username = strdup(optarg);
@@ -783,6 +834,19 @@ get_login(int argc, char *argv[], OPTIONS *options)
 		case 'q':
 			options->fquiet = 1;
 			break;
+		case 'V':
+			switch(strtol(optarg, &p, 10)) {
+			case 3: 
+				options->odbc_version = SQL_OV_ODBC3
+				;
+				break;
+			case 2:
+				options->odbc_version = SQL_OV_ODBC2;
+				break;
+			default:
+				fprintf(stderr, "warning: -V must be 2 or 3, not %s.  Using default of 3\n", optarg);
+				break;
+			}
 		case 'v':
 			options->fverbose = 1;
 			break;

